#ifndef GAME_HPP
#define GAME_HPP

class Game {
public:
    Game();
    void start();

private:
    static const int SIZE = 4;
    int board[SIZE][SIZE];
    int score;

    // Initialization
    void initBoard();
    void addRandomTile();

    // Movement
    void moveLeft();
    void moveRight();
    void moveUp();
    void moveDown();

    // Helper functions
    void transpose();
    void reverseRow(int rowIndex);
    void compressRow(int row[4]);
    void mergeRow(int row[4]);

    // Logic
    bool checkGameOver();
    bool hasEmptyCell();
    bool canMerge();

    // UI
    void printBoard();
};

#endif
